program Globe02;
{$N+}
uses graph2, crt;

var
  data: array[0..25,0..40] of Point3D;
  t1, t2 : integer;
  toets : char;

Procedure Bol(Straal, A, B: Integer; var P: Point3D);
Var
  S1, C1, S2, C2, s3, c3: Real;
Begin
  S1 := Sin(A*Rad); C1 := Cos(A*Rad);
  S2 := Sin(B*Rad); C2 := Cos(B*Rad);

  P.X := Straal * C1 * C2;
  P.Y := Straal * C1 * S2;
  P.Z := Straal * S1
End;


Procedure Bereken(Straal, AantalHor, AantalVer: Integer; Hx, Hy, Hz: Integer);
Var
  P1, P2: Point3d;
  A, B  : real;
  BreedteHoek: Real;
  VertHoek   : Real;
  a1, a2 : byte;
  t : char;
Begin

  for a1 := 0 to 25 do
  begin
    for a2 := 0 to 40 do
    begin
      Data[a1,a2].x := 0.0;
      Data[a1,a2].y := 0.0;
      Data[a1,a2].z := 0.0
    end
  end;

  (* A : -90 tot +90 *)
  (* B : 0 tot 360   *)

  t1 := 0;

  If AantalHor = 0 then AantalHor := 5;
  If AantalVer = 0 then AantalVer := 5;

  BreedteHoek := 180 / AantalHor;     (* breedtelijn om de zoveel graden *)
  VertHoek    := 360 / AantalVer;     (* breedtelijn verdeeld in zoveel hoeken *)

  for a1 := 0 to AantalHor do
  begin
    B := 0;
    A := -90 + a1*BreedteHoek;
    Bol(Straal, trunc(A), trunc(B), P1);
    Rotate(Hx, Hy, Hz, P1);
    t2 := 0;
    inc(t1);
    Data[t1,t2] := P1;
    for a2 := 0 to AantalVer do
    begin
      inc(t2);
      B := a2*VertHoek;
      Bol(Straal, trunc(A), trunc(B), P2);
      Rotate(Hx, Hy, Hz, P2);
      Data[t1,t2] := P2;
     end;
  end;

End;


procedure Teken(Klr: byte);
var
  u, v: Byte;
begin
  u := t1;
  v := t2;

  for u := 1 to t2-1 do
   for v := 1 to t1-1 do
   begin
     Lijn3( Data[v,u], Data[v+1,u], klr);
     Lijn3( Data[v,u], Data[v, u+1], klr)
   end;
end;


Procedure Roteer(x, y, z: real);
var
  S1, S2, S3, C1, C2, C3: Real;
  P, PUit               : Point3D;
  u, v                  : Byte;
begin

  S1 := Sin(X * Rad);
  C1 := Cos(X * Rad);
  S2 := Sin(Y * Rad);
  C2 := Cos(Y * Rad);
  S3 := Sin(Z * Rad);
  C3 := Cos(Z * Rad);

  u := t1;
  v := t2;

  for u := 0 to t1 do
    for v := 0 to t2 do
    begin
      P := Data[u,v];
      PUit.X := P.X*(C2*C3) + P.Y*(C2*S3) + P.Z*(-S2);
      PUit.Y := P.X*(S1*S2*C3-C1*S3) + P.Y*(S1*S2*S3+C1*C3) + P.Z*(S1*C2);
      PUit.Z := P.X*(C1*S2*C3+S1*S3) + P.Y*(C1*S2*S3-S1*C3) + P.Z*(C1*C2);
      Data[u,v] := PUIt
    end;
end;



Begin
  GrMode(egA16);
  InitPerspectief(true,400);
  thebase.u := 320;
  thebase.v := 175;
  Bereken(120, 10, 10, 30, -75, 4);
  toets := #32;
  repeat
    teken(0);
    roteer(-0.0, 0.0, 3.0);
    teken(14);
    if keypressed then toets := readkey;
  until toets = #27;
  ExitGr;
End.