 UNIT GRAPH2;

 INTERFACE

 USES Dos, Crt, Graph;

 CONST
   {* Grafische modi *}
   {* VESA-driver must be loaded before using any of the SVGA-modes *}

   VGA16     = 1;           (* 640 x 480 x 16  *)
   EGA16     = 2;           (* 640 x 350 x 16  *)
   CGA16     = 3;           (* 640 x 200 x 16  *)
   VGAMono   = 4;           (* 640 x 480 z/w   *)
   EGAMono   = 5;           (* 640 x 350 z/w   *)
   MCGA256   = 6;           (* 320 x 200 x 256 *)
   VGALo256  = 7;           (* 640 x 400 x 256 *)
   VGA256    = 8;           (* 640 x 480 x 256 *)
   SVGA256   = 9;           (* 800 x 600 x 256 *)
   SVGAHi256 = 10;          (* 1024 x 768 x 256 *)

   Pi = 3.1415926;
   Rad = Pi/180;

 TYPE
   Vector = record
               dx, dy, dz: Real;
             end;

   Point3D = record
                X, Y, Z: Real;
             end;

   Face    = Array[1..5] of Byte;
             (* 4 bytes voor de nummers van de hoekpunten *)
             (* 1 byte voor de kleur van het vlak *)

   Face2D  = Array[1..4] of PointType;

   Vertex  = Array[1..2] of Byte;
             (* 2 bytes voor het start-en eindpunt *)

   Poly3D  = record
               NrPoints    : Byte;
               Points      : Array[1..80] of Point3D;
               NrFaces     : Byte;
               Faces       : Array[1..40] of Face;
               NrLines     : Byte;
               Lines       : Array[1..100] of Vertex;
               NrVisLines  : Byte;
               VisLines    : Array[1..70] of Vertex;
             end;

   Base2D  = record
                U, V: Integer;
             end;

   KleurInfo = record
                 Rood, Groen, Blauw: Byte;
               end;

   VGAPalet = Array[0..255] of KleurInfo;

 VAR
   Blue, Green, Red    : Byte;
   Rd, Gr, Bl          : Array[0..255] of Byte;
   ColorPalet          : VGAPalet;
   MaxX, MaxY          : Integer;
   Mode, Driver, Modus : Integer;
   PresentSeg          : Byte;
   TheBase             : Base2D;
   E                   : Real;
   Perspectief         : Boolean;
   Viewer              : Vector;


   Procedure PointtoVec(P: Point3D; var V: Vector);
   Procedure MakeVec(X, Y, Z: Real; var V: Vector);
   Procedure VecSub(V1, V2: Vector; var V3: Vector);
   Function Magnitude(V: Vector): real;
   Function Dot(V1, V2: Vector): real;
   Procedure Cross(V1, V2: Vector; var V3: Vector);
   Procedure VecNormal(V: Vector; var V2: Vector);
   Procedure FaceNormal(P: Poly3D; F: Byte; var N: Vector);
   Function Visible(P: Poly3d; F: Byte): Boolean;

   Procedure InitPerspectief(Flag: Boolean; d: real);
   Procedure InitPoly(var P: Poly3D);
   Procedure Rotate(AngleX, AngleY, AngleZ: Integer; var P: Point3D);
   Procedure Transform(Punt3D: Point3D; var X2D, Y2D: Integer);
   Procedure Lijn3(Punt1, Punt2: Point3D; Kleur: Integer);
   Procedure Lijn3D(P: Poly3D; Punt1, Punt2: Byte; Kleur: Integer);
   Procedure RotatePoly(var Poly: Poly3D; AngleX, AngleY, AngleZ: Integer);
   Procedure MovePoly(var Poly: Poly3D; MoveX, MoveY, MoveZ: Real);
   Procedure ScalePoly(var Poly: Poly3D; ScaleX, ScaleY, ScaleZ: Real);
   Procedure DrawAxes(Start, Stop, Color: Integer);
   Procedure AddPoint(X, Y, Z: Real; var Poly: Poly3d);
   Procedure AddFace(var P: Poly3D; A, B, C, D, Kleur: Byte);
   Procedure AddLine(var P: Poly3D; A, B: Byte);
   Procedure DrawFace(P: Poly3D; F, Kleur: Byte);
   Procedure DrawWire(P: Poly3D; Kleur: Byte);
   Procedure FillSolid(P: Poly3D; Flag: Boolean; Kleur: Integer);
   Procedure DrawSolid(P: Poly3D; Kleur: Byte);

   Procedure GrMode(VModus: Byte);
   Procedure ExitGr;
   Procedure Plot(X, Y: Integer; Kleur: Byte);
   Procedure Plot2(X, Y: Integer; Color, Intensity: Byte);
   Function LeesPixel(X, Y: Integer): Byte;
   procedure Lijn( x1, y1, x2, y2 : integer; kleur : byte );
   Procedure Palet(Kleur: Byte; Blue,Green,Red: Byte);
   Procedure AssignColor(KleurNr,Kleur: Byte);
   Procedure LeesBGR(Kleur: Byte; var Red, Green, Blue: Byte);
   Procedure LeesPalet(var P: VGAPalet);
   Procedure Blend(Kleur1,Bl1,Gr1,Rd1,Kleur2,Bl2,Gr2,Rd2: Byte);
   Procedure Verloop(Kleur1,Bl1,Gr1,Rd1,Kleur2,Bl2,Gr2,Rd2: Byte;
                     var EenPalet: VGAPalet);
   Procedure Border(Kleur: Byte);
   Procedure InitPalet1(var ColorPalet: VGAPalet);
   Procedure InitPalet2(var ColorPalet: VGAPalet);
   Procedure SetPalet(Kleur1: Byte; var ColorPalet: VGAPalet);
   Procedure CyclePalet(T: Byte; var P: VGAPalet);
   Procedure FillFace(Vlak: Face2D; Kleur: Byte);
   Procedure Ellips(Xm, Ym, Straal1, Straal2, Hoek1, Hoek2: Integer; Kleur: Byte);
   Procedure Ellips2(Xm, Ym, Straal1, Straal2 : Integer; Vulling: Byte; Kleur1, Kleur2: Byte);
   Procedure Sector2(Xm, Ym, Straal1, Straal2, Hoek1, Hoek2: Integer; Vulling, Kleur1, Kleur2: Byte);
   Procedure RechtHoek(X1,Y1,X2,Y2: Integer; Kleur: Byte);
   Procedure Vlak(X1,Y1,X2,Y2: Integer; Vulling: Byte; Kleur: Byte);
   Procedure Balk(X1,Y1,X2,Y2,Kleur,Richt,Diepte: Integer);
   Procedure DisplayTime(Kol,Rij,Klr1,Klr2: Byte);
   Procedure DisplayDate(Kol,Rij,Klr1,Klr2: Byte);

 IMPLEMENTATION

 VAR
   Regs              : Registers;
   AutoDetectPointer : Pointer;
   SuggestedMode     : Integer;

   Procedure Swap(var A, B: Integer);
   var
     Temp: Integer;
   begin
     Temp := B;
     B := A;
     A := Temp
   end;

   Procedure PointtoVec;
   begin
     v.dx := p.x;
     v.dy := p.y;
     v.dz := p.z
   end;

   Procedure MakeVec;
   begin
     v.dx := x;
     v.dy := y;
     v.dz := z
   end;

   Procedure VecSub;
   begin
     v3.dx := v2.dx - v1.dx;
     v3.dy := v2.dy - v1.dy;
     v3.dz := v2.dz - v1.dz
   end;

   Function Magnitude; (* lengte vector *)
   begin
     Magnitude := Sqrt( Sqr(v.dx) + Sqr(v.dy) + Sqr(v.dz) );
   end;

   Function Dot; (* hoek tussen 2 vectoren *)
   begin
     Dot := v1.dx*v2.dx + v1.dy*v2.dy + v1.dz*v2.dz;
   end;

   Procedure Cross; (* v3 staat loodrecht op v1 en v2 *)
   begin
     v3.dx := v1.dy*v2.dz - v1.dz*v2.dy;
     v3.dy := v1.dz*v2.dx - v1.dx*v2.dz;
     v3.dz := v1.dx*v2.dy - v1.dy*v2.dx
   end;

   Procedure VecNormal;
   var l : Real;
   begin
     l := Magnitude(v);
     if l = 0 then l := 1;
     v2.dx := v.dx/l;
     v2.dy := v.dy/l;
     v2.dz := v.dz/l
   end;

   Procedure FaceNormal;
   var v1, v2, v3, v4, v5, v6: Vector;
   begin
     Pointtovec(P.Points[P.Faces[F,1]], v1);
     Pointtovec(P.Points[P.Faces[F,2]], v2);
     Pointtovec(P.Points[P.Faces[F,4]], v3);
     VecSub(v2, v1, v4);
     VecSub(v3, v1, v5);
     Cross(v4, v5, v6);
     VecNormal(v6, N)
   end;

   Function Visible;
   var CosB, THit: Real;
       TP        : Poly3D;
       Normal    : Vector;
       t         : Byte;
   begin
     if Perspectief then
       begin
         TP := P;
         with TP do
         begin
           for t := 1 to NrPoints do
           begin
             THit := 1 / (1 - Points[t].X/E);
             Points[t].X := Points[t].X * THit;
             Points[t].Y := Points[t].Y * THit;
             Points[t].Z := Points[t].Z * THit
           end
         end;
         FaceNormal(TP, F, Normal);
         CosB := Dot(Normal, Viewer);
         if CosB <= 0 then
           Visible := False
         else
           Visible := True;
       end
     else
       begin
         FaceNormal(P, F, Normal);
         CosB := Dot(Normal, Viewer);
         if CosB <= 0 then
           Visible := False
         else
           Visible := True;
       end;
   end;


   Procedure SetMode(gm: Byte);
   begin
     SuggestedMode := gm;
   end;


   {$F+}
   function DetectVGA256 : integer;
   begin
     DetectVGA256 := SuggestedMode;
   end;
   {$F-}

   Procedure GrMode;
   var
     GraphDriver, GraphMode: Integer;

   begin
     Modus := VModus;
     case VModus of

     1: begin
          Mode  := VGAHi;
          Driver := VGA;
          Initgraph(Driver, Mode, '');
          MaxX := 640;
          MaxY := 480;
        end;

     2: begin
          Mode  := EGAHi;
          Driver := EGA;
          Initgraph(Driver, Mode, '');
          MaxX := 640;
          MaxY := 350;
        end;

     3: begin
          Mode  := EGALo;
          Driver := EGA;
          Initgraph(Driver, Mode, '');
          MaxX := 640;
          MaxY := 200;
        end;

     4: begin
          Mode  := MCGAHi;
          Driver := MCGA;
          Initgraph(Driver, Mode, '');
          MaxX := 640;
          MaxY := 480;
        end;

     5: begin
          Mode  := EGAMonoHi;
          Driver := EGA;
          Initgraph(Driver, Mode, '');
          MaxX := 640;
          MaxY := 350;
        end;

     6: begin
          MaxX := 320;
          MaxY := 200;
          SetMode(0);
          AutoDetectPointer := @DetectVGA256;
          GraphDriver := InstallUserDriver('SVGA256',AutoDetectPointer);
          GraphDriver := Detect;
          InitGraph(GraphDriver, GraphMode, '');
        end;

     7: begin
          MaxX := 640;
          MaxY := 400;
          SetMode(1);
          AutoDetectPointer := @DetectVGA256;
          GraphDriver := InstallUserDriver('SVGA256',AutoDetectPointer);
          GraphDriver := Detect;
          InitGraph(GraphDriver, GraphMode, '');
        end;

     8: begin
          MaxX := 640;
          MaxY := 480;
          SetMode(2);
          AutoDetectPointer := @DetectVGA256;
          GraphDriver := InstallUserDriver('SVGA256',AutoDetectPointer);
          GraphDriver := Detect;
          InitGraph(GraphDriver, GraphMode, '');
        end;

     9: begin
          MaxX := 800;
          MaxY := 600;
          SetMode(3);
          AutoDetectPointer := @DetectVGA256;
          GraphDriver := InstallUserDriver('SVGA256',AutoDetectPointer);
          GraphDriver := Detect;
          InitGraph(GraphDriver, GraphMode, '');
        end;

     10: begin
           MaxX := 1024;
           MaxY := 768;
           SetMode(4);
           AutoDetectPointer := @DetectVGA256;
           GraphDriver := InstallUserDriver('SVGA256',AutoDetectPointer);
           GraphDriver := Detect;
           InitGraph(GraphDriver, GraphMode, '');
        end;

     end;
   end;

   Procedure ExitGr;
   begin
     CloseGraph;
   end;

   Procedure Plot2;
   var
     col : Byte;
   Begin
     Col := 42 * (Color-1) + Intensity;
     Plot(x, y, Col)
   End;

   Procedure Palet;
   begin
     if Blue < 0 then Blue := 0;
     if Blue > 63 then Blue := 63;
     if Green < 0 then Green := 0;
     if Green > 63 then Green := 63;
     if Red < 0 then Red := 0;
     if Red > 63 then Red := 63;
     with Regs do
     begin
       AH := 16;
       AL := 16;
       BX := Kleur;
       CH := Green;
       CL := Blue;
       DH := Red;
       Intr($10,Regs)
     end;
   end;

   Procedure AssignColor;
   begin
     with Regs do
     begin
       AL := 0;
       AH := 16;
       BL := KleurNr;
       BH := Kleur;
       Intr($10,Regs)
     end;
   end;

   Procedure LeesBGR;
   begin
     with Regs do
     begin
       AH := 16;
       AL := 21;
       BX := Kleur;
       Intr($10,Regs)
     end;
     with Regs do
     begin
       Blue := CL;
       Green := CH;
       Red  := DH
     end;
   end;

   Procedure LeesPalet;
   var
     C: Byte;
   begin
     for C := 0 to 255 do LeesBGR(C, P[C].Rood, P[C].Groen, P[C].Blauw);
   end;

   Procedure Blend;
   var
     Dbl,Dgr,Drd : Real;
     i,Bl,Gr,Rd  : Byte;
     Aantal      : Word;
   begin
     Aantal := Kleur2 - Kleur1;
     Dbl := (Bl2 - Bl1) / Aantal;
     Dgr := (Gr2 - Gr1) / Aantal;
     Drd := (Rd2 - Rd1) / Aantal;
     for i := 0 to Aantal do
     begin
       Bl := trunc(Bl1 + i * Dbl + 0.5);
       Gr := trunc(Gr1 + i * Dgr + 0.5);
       Rd := trunc(Rd1 + i * Drd + 0.5);
       Palet(Kleur1+i, Bl, Gr, Rd)
     end;
   end;

   Procedure VerLoop;
   var
     Dbl,Dgr,Drd : Real;
     i,Bl,Gr,Rd  : Byte;
     Aantal      : Word;
   begin
     Aantal := Kleur2 - Kleur1;
     Dbl := (Bl2 - Bl1) / Aantal;
     Dgr := (Gr2 - Gr1) / Aantal;
     Drd := (Rd2 - Rd1) / Aantal;
     for i := 0 to Aantal do
     begin
       with EenPalet[Kleur1+i] do
       begin
         Blauw := trunc(Bl1 + i * Dbl + 0.5);
         Groen := trunc(Gr1 + i * Dgr + 0.5);
         Rood  := trunc(Rd1 + i * Drd + 0.5)
       end
     end
   end;

   Procedure Border;
   begin
     with Regs do
     begin
       AH := 16;
       AL := 1;
       BH := Kleur;
       Intr($10,Regs)
     end
   end;

  Procedure InitPalet1;
  var i: Byte;
  Begin
    for i := 0 to 63 do                     (* grijswaarden *)
    begin
      ColorPalet[i].rood  := i;
      ColorPalet[i].groen := i;
      ColorPalet[i].blauw := i
    end;
    for i := 64 to 127 do                    (* rood *)
    begin
      ColorPalet[i].rood  := i - 64;
      ColorPalet[i].groen := 0;
      ColorPalet[i].blauw := 0
    end;
    for i := 128 to 191 do                    (* groen *)
    begin
      ColorPalet[i].rood  := 0;
      ColorPalet[i].groen := i - 128;
      ColorPalet[i].blauw := 0
    end;
    for i := 192 to 255 do                    (* blauw *)
    begin
      ColorPalet[i].rood  := 0;
      ColorPalet[i].groen := 0;
      ColorPalet[i].blauw := i - 192
    end;
    SetPalet(0, ColorPalet);
  End;

  Procedure InitPalet2;
  var i: Byte;
  Begin
    for i := 0 to 41 do                     (* blauw *)
    begin
      ColorPalet[i].rood  := 0;
      ColorPalet[i].groen := 0;
      ColorPalet[i].blauw := Round(i * 1.53)
    end;
    for i := 42 to 83 do                    (* groen *)
    begin
      ColorPalet[i].rood  := 0;
      ColorPalet[i].groen := Round((i - 42) * 1.53);
      ColorPalet[i].blauw := 0
    end;
    for i := 84 to 125 do                   (* geel *)
    begin
      ColorPalet[i].rood  := Round((i-84) * 1.53);
      ColorPalet[i].groen := Round((i-84) * 1.53);
      ColorPalet[i].blauw := 5
    end;
    for i := 126 to 167 do                  (* rood *)
    begin
      ColorPalet[i].rood  := Round((i-126) * 1.53);
      ColorPalet[i].groen := 0;
      ColorPalet[i].blauw := 0
    end;
    for i := 168 to 209 do                  (* paars *)
    begin
      ColorPalet[i].rood  := Round((i-168) * 1.53);
      ColorPalet[i].groen := 0;
      ColorPalet[i].blauw := Round((i-168) * 1.53)
    end;
    for i := 210 to 252 do                  (* grijswaarden *)
    begin
      ColorPalet[i].rood  := Round((i-210) * 1.53);
      ColorPalet[i].groen := Round((i-210) * 1.53);
      ColorPalet[i].blauw := Round((i-210) * 1.53)
    end;
    Setpalet(0, ColorPalet)
  End;

  Procedure SetPalet;
  begin
    with Regs do
    begin
      AX := $1012;
      BX := Kleur1;
      CX := 256 - Kleur1;
      ES := Seg(Colorpalet);
      DX := Ofs(ColorPalet)
    end;
    Intr($10, Regs);
  end;

  Procedure CyclePalet;
  var teller: Byte;
      tmp: KleurInfo;
  begin
    repeat
      tmp := p[0];
      for teller := 1 to 255 do
        p[teller-1] := p[teller];
      p[255] := tmp;
      setpalet(0,p);
      delay(t*5);
    until keypressed;
  end;

  Procedure FillFace;
  begin
    SetFillStyle(1, Kleur);
    SetColor(Kleur);
    FillPoly(4, Vlak);
    (*DrawPoly(4, Vlak)*)
  end;

  Procedure Ellips;
  begin
    SetColor(Kleur);
    Ellipse(Xm, Ym, Hoek1, Hoek2, Straal1, Straal2);
  end;

  Procedure Ellips2;
  begin
    SetColor(Kleur1);
    SetFillStyle(Vulling, Kleur2);
    FillEllipse(Xm, Ym, Straal1, Straal2);
  end;

  Procedure Sector2;
  begin
    SetColor(Kleur1);
    SetFillStyle(Vulling, Kleur2);
    Sector(Xm, Ym, Hoek1, Hoek2, Straal1, Straal2);
  end;

  Procedure RechtHoek;
  begin
    SetColor(Kleur);
    Rectangle(X1, Y1, X2, Y2);
  end;

  Procedure Vlak;
  begin
    SetFillStyle(Vulling, Kleur);
    Bar(X1, Y1, X2, Y2)
  end;

  Procedure Bereken(Hoek, Afstand: Integer; var Dx, Dy: Integer);
  var S, C: Real;
  begin
    S := Sin(Hoek * Rad);
    C := Cos(Hoek * Rad);
    Dx := trunc(Afstand * C + 0.5);
    Dy := trunc(Afstand * S + 0.5)
  end;

  Procedure Balk;
  var
    Old, New  : Array[1..3] of PointType;
    Xv, Yv, t : Integer;
  begin
    if X2 < X1 then Swap(X1, X2);
    if Y2 < Y1 then Swap(Y1, Y2);
    Richt := Richt mod 360;
    Bereken(Richt, Diepte, Xv, Yv);
    case Richt of
      0..90    : begin
                   Old[1].x := x2;
                   Old[1].y := y2;
                   Old[2].x := x2;
                   Old[2].y := y1;
                   Old[3].x := x1;
                   Old[3].y := y1
                 end;

      91..180  : begin
                   Old[1].x := x2;
                   Old[1].y := y1;
                   Old[2].x := x1;
                   Old[2].y := y1;
                   Old[3].x := x1;
                   Old[3].y := y2
                 end;

      181..270:  begin
                   Old[1].x := x1;
                   Old[1].y := y1;
                   Old[2].x := x1;
                   Old[2].y := y2;
                   Old[3].x := x2;
                   Old[3].y := y2
                 end;
      271..359:  begin
                   Old[1].x := x1;
                   Old[1].y := y2;
                   Old[2].x := x2;
                   Old[2].y := y2;
                   Old[3].x := x2;
                   Old[3].y := y1
                 end;
     end;     (* end van case *)
    for t := 1 to 3 do
    begin
      New[t].x := Old[t].x + xv;
      New[t].y := Old[t].y - yv
    end;
    RechtHoek(x1,y1,x2,y2,kleur);
    for t := 1 to 3 do
      Lijn(Old[t].x, Old[t].y, New[t].x, New[t].y, Kleur);
     (* verbindt oude rechth. met nieuwe *)
    for t := 1 to 2 do
      Lijn(New[t].x,New[t].y,New[t+1].x,New[t+1].y,Kleur);
    (* verbindt zichtbare punten van verschoven rechth. *)
  end;

  Function ExtraNul(Getal: Word): String;
  var
    HulpStr: String;
  begin
    Str(Getal, HulpStr);
    if Getal < 10 then
      ExtraNul := '0'+HulpStr
    else
      ExtraNul := HulpStr;
  end;

  Procedure DisplayTime;
  var
    Uur, Min, Sec, HSec: Word;
    TStr               : String;
    TLen               : Byte;
  begin
    GetTime( Uur, Min, Sec, HSec);
    TStr := ExtraNul(Uur) + ':' + ExtraNul(Min) + ':' + ExtraNul(Sec);
    TLen := Length(TStr);
    if (Kol + Tlen) >= 80 then Kol := 80 - TLen;
    GotoXY(Kol, Rij);
    TextColor(Klr1); TextBackground(Klr2);
    Write(TStr)
  end;

  Procedure DisplayDate(Kol, Rij, Klr1, Klr2: Byte);
  const
    DagNaam   : Array[0..6] of String[10] =
                (' Zondag',' Maandag',' Dinsdag',' Woensdag',' Donderdag',
                 ' Vrijdag',' Zaterdag');
    MaandNaam : Array[1..12] of String[10] =
               (' Januari',' Februari ',' Maart',' April',' Mei ',' Juni ',
                ' Juli ',' Augustus ',' September ',' Oktober ',' November ',
                ' December ');
  var
    Jaar, Maand, Dag, DagvanWeek: Word;
    Dlen                        : Byte;
    DStr                        : String;
  begin
    GetDate( Jaar, Maand, Dag, DagvanWeek);
    DStr := DagNaam[DagvanWeek] + ', ' + ExtraNul(Dag) + MaandNaam[Maand]
           + ExtraNul(Jaar);

    (* ExtraNul(Jaar) is alleen maar nodig om Jaar naar een string *)
    (* te converteren *)

    DLen := Length(DStr);
    if (Kol + DLen) >= 80 then Kol := 80 - DLen;
    TextColor(Klr1); TextBackground(Klr2);
    GotoXY(Kol, Rij);
    Write(DStr)
  end; 

  (*                      *)
  (*       / 1  0   0  \   *)
  (* Rx =   0  C1  S1    Rotatie rond X-as *)
  (*       \ 0 -S1  C1 /   *)
  (*                       *)
  (*       / C2  0 -S2 \   *)
  (* Ry =   0   1  0     Rotatie rond Y-as *)
  (*       \ S2  0  C2 /   *)
  (*                       *)
  (*       / C3  S3  0 \   *)
  (* Rz =  -S3  C3  0    Rotatie rond Z-as *)
  (*       \ 0   0   1 /   *)
  (*                       *)
  (*         / C2.C3            C2.S3            -S2   \  *)
  (* Rxyz =   S1.S2.C3-C1.S3   S1.S2.S3+C1.C3   S1.C2   *)
  (*         \ C1.S2.C3+S1.S3   C1.S2.S3-S1.C3   C1.C2 /  *)
  (* Rotatie rond de 3 assen                              *)

  Procedure InitPerspectief;
  begin
    Perspectief := Flag;
    E := d
  end;

  Procedure InitPoly;
  var t,t2: Byte;
  begin
    with P do
    begin

      NrPoints   := 80;
      NrFaces    := 40;
      NrLines    := 100;
      NrVisLines := 70;

      for t := 1 to NrPoints do
      begin
        Points[t].X := 0;
        Points[t].Y := 0;
        Points[t].z := 0
      end;

      for t := 1 to NrFaces do
        for t2 := 1 to 5 do
           Faces[t,t2] := 0;

      for t := 1 to NrLines do
        for t2 := 1 to 2 do
           Lines[t,t2] := 0;

      for t := 1 to NrVisLines do
        for t2 := 1 to 2 do
           VisLines[t,t2] := 0;

      NrPoints   := 0;
      NrFaces    := 0;
      NrLines    := 0;
      NrVisLines := 0;
    end

  end;

  Procedure Rotate;
  var
    S1, S2, S3, C1, C2, C3: Real;
    PUit: Point3D;
  begin
    S1 := Sin(AngleX * Rad);
    C1 := Cos(AngleX * Rad);
    S2 := Sin(AngleY * Rad);
    C2 := Cos(AngleY * Rad);
    S3 := Sin(AngleZ * Rad);
    C3 := Cos(AngleZ * Rad);
    PUit.X := P.X*(C2*C3) + P.Y*(C2*S3) + P.Z*(-S2);
    PUit.Y := P.X*(S1*S2*C3-C1*S3) + P.Y*(S1*S2*S3+C1*C3) + P.Z*(S1*C2);
    PUit.Z := P.X*(C1*S2*C3+S1*S3) + P.Y*(C1*S2*S3-S1*C3) + P.Z*(C1*C2);
    P := PUIt
  end;

  Procedure TransForm;
  var
    THit: real;
  begin
    if Perspectief then
    begin
      THit := 1 / (1 - Punt3D.X/E);
      X2D := trunc(TheBase.U + Punt3D.Y * THit);
      Y2D := trunc(TheBase.V - Punt3d.Z * THit)
    end
    else
    begin
      X2D := TheBase.U + Round(Punt3D.Y );
      Y2D := TheBase.V - Round(Punt3D.Z )
    end
  end;

  Procedure Plot;
  begin
    PutPixel(X, Y, Kleur);
  end;

  Function LeesPixel;
  begin
    LeesPixel := GetPixel(X, Y);
  end;

  Procedure Lijn;
  begin
    SetColor(Kleur);
    Line(x1, y1, x2, y2)
  end;

  Procedure Lijn3;
  var
    X1, Y1, X2, Y2: Integer;
  begin
    Transform(Punt1, X1, Y1);
    Transform(Punt2, X2, Y2);
    Lijn(X1, Y1, X2, Y2, Kleur)
  end;

  Procedure Lijn3D;
  var
    X1, Y1, X2, Y2: integer;
  begin
    TransForm(P.Points[Punt1], X1, Y1);
    TransForm(P.Points[Punt2], X2, Y2);
    Lijn(X1, Y1, X2, Y2, Kleur)
  end;

  Procedure RotatePoly;
  var
    S1, S2, S3, C1, C2, C3: Real;
    F1, F2, F3, F4, F5, F6, F7, F8, F9: Real;
    PUit: Point3D;
    t: Integer;
  begin
    S1 := Sin(AngleX * Rad);
    C1 := Cos(AngleX * Rad);
    S2 := Sin(AngleY * Rad);
    C2 := Cos(AngleY * Rad);
    S3 := Sin(AngleZ * Rad);
    C3 := Cos(AngleZ * Rad);
    F1 := C2 * C3;  F2 := C2*S3;  F3 := -S2;
    F4 := S1*S2*C3-C1*S3;  F5 := S1*S2*S3+C1*C3;  F6 := S1*C2;
    F7 := C1*S2*C3+S1*S3;  F8 := C1*S2*S3-S1*C3;  F9 := C1*C2;
    with Poly do
    begin
      for t := 1 to NrPoints do
      begin
        PUit.X := Points[t].X*F1 + Points[t].Y*F2 + Points[t].Z*F3;
        PUit.Y := Points[t].X*F4 + Points[t].Y*F5 + Points[t].Z*F6;
        PUit.Z := Points[t].X*F7 + Points[t].Y*F8 + Points[t].Z*F9;
        Points[t] := PUit
      end
    end
  end;

  Procedure MovePoly;
  var
    T: Integer;
  begin
    for t := 1 to Poly.NrPoints do
    begin
      Poly.Points[t].X := Poly.Points[t].X + MoveX;
      Poly.Points[t].Y := Poly.Points[t].Y + MoveY;
      Poly.Points[t].Z := Poly.Points[t].Z + MoveZ
    end
  end;

  Procedure ScalePoly;
  var
    T: Integer;
  begin
    for t := 1 to Poly.NrPoints do
    begin
      Poly.Points[t].X := Poly.Points[t].X * ScaleX;
      Poly.Points[t].Y := Poly.Points[t].Y * ScaleY;
      Poly.Points[t].Z := Poly.Points[t].Z * ScaleZ
    end
  end;

  Procedure DrawAxes;
  var
    Xas, Yas, Zas: Array[1..2] of Point3D;
  begin
    Xas[1].x := Start; Xas[1].y := 0    ; Xas[1].z := 0;
    Xas[2].x := Stop ; Xas[2].y := 0    ; Xas[2].z := 0;
    Yas[1].x := 0    ; Yas[1].y := Start; Yas[1].z := 0;
    Yas[2].x := 0    ; Yas[2].y := Stop ; Yas[2].z := 0;
    Zas[1].x := 0    ; Zas[1].y := 0    ; Zas[1].z := Start;
    Zas[2].x := 0    ; Zas[2].y := 0    ; Zas[2].z := Stop;
    Lijn3(Xas[1], Xas[2], Color);
    Lijn3(Yas[1], Yas[2], Color);
    Lijn3(Zas[1], Zas[2], Color);
    Lijn3(Xas[2], Xas[2], 15);
    Lijn3(Yas[2], Yas[2], 14);
    Lijn3(Zas[2], Zas[2], 13)
  end;

  Procedure AddPoint;
  begin
    Inc(Poly.NrPoints);
    Poly.Points[Poly.NrPoints].x := X;
    Poly.Points[Poly.NrPoints].y := Y;
    Poly.Points[Poly.NrPoints].z := Z
  end;

  Procedure AddFace;
  begin
    Inc(P.NrFaces);
    P.Faces[P.NrFaces,1] := A;
    P.Faces[P.NrFaces,2] := B;
    P.Faces[P.NrFaces,3] := C;
    P.Faces[P.NrFaces,4] := D;
    P.Faces[P.NrFaces,5] := Kleur
  end;

  Procedure AddLine;
  begin
    Inc(P.NrLines);
    P.Lines[P.NrLines,1] := A;
    P.Lines[P.NrLines,2] := B;
  end;

  Procedure DrawFace;
  begin
    Lijn3D(P, P.Faces[F,1], P.Faces[F,2], Kleur);
    Lijn3D(P, P.Faces[F,2], P.Faces[F,3], Kleur);
    Lijn3D(P, P.Faces[F,3], P.Faces[F,4], Kleur);
    Lijn3D(P, P.Faces[F,1], P.Faces[F,4], Kleur);
  end;

  Procedure DrawWire;
  var Teller: Byte;
  begin
    for Teller := 1 to P.NrLines do
      Lijn3D(P, P.Lines[Teller,1], P.Lines[Teller,2], Kleur);
  end;

  Procedure FillSolid;
  var t1, t2, clr: Byte;
      F2         : Face2d;
  begin
    for t1 := 1 to P.NrFaces do
    begin
      if Visible(P, t1) then
      begin
        for t2 := 1 to 4 do
          Transform(P.Points[P.Faces[t1, t2]], F2[t2].x, F2[t2].y);
        if Flag then
          clr := P.Faces[t1,5]      (* 5de byte is immers de kleur *)
        else
          clr := Kleur;
        FillFace(F2, clr)
      end
    end
  end;

  Procedure AddLineToVisibleLinesList(var P: Poly3D; L: Byte);
  begin
    inc(P.NrVisLines);
    P.VisLines[P.NrVisLines,1] := P.Lines[L,1];
    P.VisLines[P.NrVisLines,2] := P.Lines[L,2]
  end;

  Procedure DrawSolid;
  var t1: Byte;
  begin
    for t1 := 1 to P.NrFaces do
      if Visible(P, t1) then DrawFace(P, t1, Kleur);
  end;

 BEGIN
   Perspectief := FALSE;
   E := 0;
   MakeVec(1, 0, 0, Viewer);
 END.
